/* GtiaDataSource.m - 
 GtiaDataSource class for the
 Macintosh OS X SDL port of Atari800
 Mark Grebe <atarimac@kc.rr.com>
 */

#import "GtiaDataSource.h"
#import "ControlManager.h"
#import "gtia.h"

@implementation GtiaDataSource
	
static REG_S regs[] = 
{
	{"HPOSP0",&GTIA_HPOSP0,(0xd000 + GTIA_OFFSET_HPOSP0)},
	{"HPOSP1",&GTIA_HPOSP1,(0xd000 + GTIA_OFFSET_HPOSP1)},
	{"HPOSP2",&GTIA_HPOSP2,(0xd000 + GTIA_OFFSET_HPOSP2)},
	{"HPOSP3",&GTIA_HPOSP3,(0xd000 + GTIA_OFFSET_HPOSP3)},
	{"HPOSM0",&GTIA_HPOSM0,(0xd000 + GTIA_OFFSET_HPOSM0)},
	{"HPOSM1",&GTIA_HPOSM1,(0xd000 + GTIA_OFFSET_HPOSM1)},
	{"HPOSM2",&GTIA_HPOSM2,(0xd000 + GTIA_OFFSET_HPOSM2)},
	{"HPOSM3",&GTIA_HPOSM3,(0xd000 + GTIA_OFFSET_HPOSM3)},
	{"SIZEP0",&GTIA_SIZEP0,(0xd000 + GTIA_OFFSET_SIZEP0)},
	{"SIZEP1",&GTIA_SIZEP1,(0xd000 + GTIA_OFFSET_SIZEP1)},
	{"SIZEP2",&GTIA_SIZEP2,(0xd000 + GTIA_OFFSET_SIZEP2)},
	{"SIZEP3",&GTIA_SIZEP3,(0xd000 + GTIA_OFFSET_SIZEP3)},
	{"GRAFP0",&GTIA_GRAFP0,(0xd000 + GTIA_OFFSET_GRAFP0)},
	{"GRAFP1",&GTIA_GRAFP1,(0xd000 + GTIA_OFFSET_GRAFP1)},
	{"GRAFP2",&GTIA_GRAFP2,(0xd000 + GTIA_OFFSET_GRAFP2)},
	{"GRAFP3",&GTIA_GRAFP3,(0xd000 + GTIA_OFFSET_GRAFP3)},
	{"COLPM0",&GTIA_COLPM0,(0xd000 + GTIA_OFFSET_COLPM0)},
	{"COLPM1",&GTIA_COLPM1,(0xd000 + GTIA_OFFSET_COLPM1)},
	{"COLPM2",&GTIA_COLPM2,(0xd000 + GTIA_OFFSET_COLPM2)},
	{"COLPM3",&GTIA_COLPM3,(0xd000 + GTIA_OFFSET_COLPM3)},
	{"COLPF0",&GTIA_COLPF0,(0xd000 + GTIA_OFFSET_COLPF0)},
	{"COLPF1",&GTIA_COLPF1,(0xd000 + GTIA_OFFSET_COLPF1)},
	{"COLPF2",&GTIA_COLPF2,(0xd000 + GTIA_OFFSET_COLPF2)},
	{"COLPF3",&GTIA_COLPF3,(0xd000 + GTIA_OFFSET_COLPF3)},
	{"COLBK",&GTIA_COLBK,(0xd000 + GTIA_OFFSET_COLBK)},
	{"PRIOR",&GTIA_PRIOR,(0xd000 + GTIA_OFFSET_PRIOR)},
	{"VDELAY",&GTIA_VDELAY,(0xd000 + GTIA_OFFSET_VDELAY)},
	{"GRACTL",&GTIA_GRACTL,(0xd000 + GTIA_OFFSET_GRACTL)},
};

static int numRegs = sizeof(regs)/sizeof(REG_S);

-(id) init
{
	regDefs = regs;
	regCount = numRegs;
	
	return [super init];
}

@end
